//
// Implementazione della Classi Dipendenti Impiegati e Manager.
// Seconda versione: Virtual functions.
//

#include <iostream.h>
#include <strings.h>

#include "Impiegati2.H"


// Costruttore per il tipo di dato Dipendete.
Dipendente::Dipendente(char *n, int e)
{
  strcpy(nome, n);
  eta = e;
  salario = 1500000;	// Salario di default
}


// Stampa i dati essenziali relativi al Dipendente.
void Dipendente::PrintPInfo()
{
  cout << nome << endl;
  cout << "L'eta` e` " << eta << endl;
  cout << "Il salario e` " << salario << endl;
}


// Virtual Destructor
Dipendente::~Dipendente()
{ 
  cout << "Dipendente:: Distruggo un oggetto della classe" << endl;
}




// Costruttore per la classe Impiegato. La lista di inizializzazione invoca il
// costruttore per la classe base Dipendente.
Impiegato::Impiegato(char *n, char *d, int e):
  Dipendente(n, e)
{
  SetDip(d);		// Assegna un dipartimento iniziale
  salario = 1700000;	// Salario e` un membro Protetto della classe base,
			// quindi posso accederci direttamente.
}


// Virtual Destructor
Impiegato::~Impiegato()
{ 
  cout << "Impiegato:: Distruggo un oggetto della classe" << endl;
}


// Assegna il Dipartimento per l'impiegato.
void Impiegato::SetDip(char *d)
{
  strcpy(dipartimento, d);
}

// Ridefinizione della funzione Print per la classe Impiegato.
void Impiegato::Print()
{
  cout << "Sig. ";

  PrintPInfo();

  cout << "Il dipartimento e` " << dipartimento << endl;
}


// Come lavora un Impiegato
void Impiegato::Lavora()
{
  cout << Nome() << " lavora dalle 9 alle 18!" << endl;
}



// Costruttore per la classe Manager. La lista di inizializzazione invoca il
// costruttore per la classe base Dipendente.
Manager::Manager(char *n, int l, int e):
  Dipendente(n, e)
{
  livello = l;
  numimp = 0;		// Inizialmente non ha impiegati sotto di se.
  salario = 130000000;	// Salario e` un membro Protetto della classe base,
			// quindi posso accederci direttamente.
}


// Virtual Destructor
Manager::~Manager()
{ 
  cout << "Manager:: Distruggo un oggetto della classe" << endl;
}


// Ridefinizione della funzione Print per la classe Manager.
void Manager::Print()
{
  cout << "Dott. Ing. Cav. ";

  PrintPInfo();

  cout << "Il livello e` " << livello << endl;

  cout << "Il suo gruppo di lavoro e` costituito da " 
       << numimp << " Dip." << endl;

  cout << "============" << endl;

  for (int i = 0; i < numimp; i++)
    cout << "\t" << gruppo[i]->Nome() << endl;

  cout << "============" << endl;
}


// Aggiunge un dipendente al gruppo di un Manager
void Manager::AddToGrp(Dipendente *i)
{
  gruppo[numimp++] = i;
}


// Come lavora un Manager
void Manager::Lavora()
{
  cout << Nome() << " lavora e ... " << endl;
  for (int i = 0; i < numimp; i++)
    cout << "\tDa ordini a " << gruppo[i]->Nome() << endl;
}
