//
// Classi per rappresentare un Impiegato ed un Manager.
// Seconda versione. Funzioni virtuali.
//

const MAXSTRING = 30;
const MAXGRUPPO = 15;


// Classe base Dipendente
class Dipendente {
private:
  char nome[MAXSTRING];		// Nome del dipendente
  int eta;			// L'eta

protected:
  float salario;		// Il salario

  void PrintPInfo();		// Stampa delle informazioni personali

public:
  Dipendente(char *n, int e);	// Il costruttore
  virtual ~Dipendente();	// Il distruttore

  char *Nome()
    { return(nome); }

  void SetSalario(float s)	// Assegna un salario
    { salario = s; }

  virtual void Print() = 0;	// Funzione virtuale pura! Non abbiamo molte
				// Informazioni ragionevoli da stampare.

  virtual void Lavora() = 0;	// Funzione virtuale pura! Non sappiamo come 
				// lavora un generico dipendente.
};


// Classe derivata Impiegato: un Impiegato E` un dipendente!
class Impiegato: public Dipendente {
private:
  char dipartimento[MAXSTRING];		// Il dipartimento a cui e` assegnato

public:
  Impiegato(char *n, char *d, int e);	// Il costruttore
  virtual ~Impiegato();			// Il distruttore

  void Print();			// Stampa le informazioni relative all'Impiegato
  void SetDip(char *d);		// Assegna un Dipartimento
  void Lavora();		// Come lavora un Impiegato
};



// Classe derivata Manager: un Manager E` un dipendente!
class Manager: public Dipendente {
private:
  int livello;			// Un Manager ha un livello
  Dipendente *gruppo[MAXGRUPPO];// Un Manager controlla un gruppo di Dipendenti
  int numimp;			// Il numero di impiegati del gruppo

public:
  Manager(char *n, int l, int e);	// Il costruttore
  virtual ~Manager();			// Il distruttore

  virtual void Print();		// Stampa le informazioni relative al Manager
  void AddToGrp(Dipendente *i);	// Aggiunge un dipendente al gruppo del Manager
  void Lavora();		// Come lavora un Manager
};
